# How to train ELECTRA

1. Install chebai as a local python package
    `pip install -e chebai`. Note that your python version has to be compatible with `torch`.
    The `data` folder has to be in the working directory for pre-training and training. `JCI` corresponds to the dataset ChEBI500 and `JCI_extended` to ChEBI500Plus.
2. Move to the module folder.
3. To pretrain run `python -m chebai train ElectraPre+SWJ [batchsize]`. The resulting model will be stored in `logs/ElectraPre__SWJpre_smiles_token_unlabeled/[version]/best_checkpoints/`.
4. To fine-tune run `python -m chebai train Electra+JCIExt [batchsize] [path_to_checkpoint]`. The resulting model will be stored in `logs/Electra__JCI_extended_smiles_token/[version]/best_checkpoints/`.
5. You can load the final model using the following snippet:
```
from chebai.models.electra import Electra
model = Electra.from_checkpoint("path_to_checkpoint")
```

# How to get a prediction

 Run `python -m chebai predict Electra+SWJ [checkpoint] [smiles]` where `smiles` is the path to a text file of smiles string, with one string per line (e.g. hazardous.txt). The predictions will be generated in a single JSON file that contains the predicted membership values. Our evaluation used a threshold of 0.5 for predictions. Note that whilst the actual predictions are rather fast, this process may be slow because the entire prediction will be serialized to json.